"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const ganache = require("ganache-cli");
class Sandbox {
    constructor(options) {
        this.options = Object.assign({ port: 8545 }, options);
        this._server = ganache.server(this.options);
        this._server.provider.setMaxListeners(999999);
    }
    static createProvider(options) {
        const provider = ganache.provider(options);
        provider.setMaxListeners(999999);
        return provider;
    }
    static createServer(options) {
        const server = ganache.server(options);
        server.provider.setMaxListeners(999999);
        return server;
    }
    get provider() {
        return this.server.provider;
    }
    get server() {
        return this._server;
    }
    listen() {
        return __awaiter(this, void 0, void 0, function* () {
            yield new Promise((resolve, reject) => {
                this.server.listen(this.options.port, (e) => e ? reject(e) : resolve());
            });
            return this;
        });
    }
    close() {
        return __awaiter(this, void 0, void 0, function* () {
            this._server.close();
            return this;
        });
    }
}
exports.Sandbox = Sandbox;
//# sourceMappingURL=sandbox.js.map